import os, regex, string, time

# Yes, i know this is incredibly ugly.  The database should be a class,
# storing data in the filesystem is very inefficient, etc.  -- Ping

from roundup_config import *
# This module uses two constants from the ronudup_config module:
# BUGDIR needs to be set to point us at the directory where we will
# store all of the database info.  ROUNDUPURL needs to be set to the
# full URL of the roundup CGI script.

# ------------------------------------------------------ database access
priorityvalues = ["1-critical", "2-urgent", "3-bug", "4-feature", "5-wish"]

statusvalues = ["unread", "deferred", "chatting", "need-eg",
                "in-progress", "testing", "done-cbb", "resolved"]

bugpat = regex.compile("\([A-Z]+\)\([0-9]*\)")

def maketimedate(sec):
    return time.strftime("%H:%M on %d %b %Y", time.localtime(sec))

def mkpath(path):
    parent, name = os.path.split(path)
    if not os.path.exists(parent): mkpath(parent)
    if not os.path.exists(path): os.mkdir(path)
    try: os.chmod(path, 0777)
    except: pass

def listbugs():
    mkpath(BUGDIR)
    return os.listdir(BUGDIR)
    
def makeid(newcat):
    newind = 0
    for bug in listbugs():
        if bugpat.match(bug) <= 0: continue
        cat, ind = bugpat.group(1), bugpat.group(2)
        if cat == newcat:
            newind = max(string.atoi(ind), newind)
    return "%s%d" % (newcat, newind + 1)

def dict_get(dict, key, default=None):
    if dict.has_key(key): return dict[key]
    return default

class Bug:
    def __init__(self, id):
        self.id = id
        self.vars = {}
        self.dir = BUGDIR + "/" + id
        mkpath(self.dir)
        if os.path.exists(self.dir + "/info"):
            execfile(self.dir + "/info", self.vars)
        try: os.chmod(self.dir + "/info", 0666)
        except: pass

    def getdesc(self):
        return dict_get(self.vars, "desc", "")

    def getctime(self):
        return dict_get(self.vars, "ctime", self.getmtime())
        
    def getmtime(self):
        mtime = 0
        for file in ("info", "notes", "mbox"):
            try:
                time = os.stat(self.dir + "/" + file)[8]
                mtime = max(mtime, time)
            except: pass
        return mtime

    def getcdate(self):
        return maketimedate(self.getctime())

    def getmdate(self):
        return maketimedate(self.getmtime())

    def getstatus(self):
        return dict_get(self.vars, "status", "unread")

    def getpriority(self):
        return dict_get(self.vars, "priority", "5-wish")

    def getfixer(self):
        return dict_get(self.vars, "fixer", "")

    def getnosy(self):
        return dict_get(self.vars, "nosy", "")

    def getnosylist(self):
        nosy = self.getnosy()
        nosy = string.join(string.split(nosy, ","))
        return string.split(nosy)

    def setnosy(self, nosy):
        nosy = string.join(string.split(nosy, ","))
        self.setnosylist(string.split(nosy))

    def setnosylist(self, nosy):
        nosydict = {}
        for name in nosy: nosydict[name] = 1
        self.vars["nosy"] = string.join(nosydict.keys(), ",")

    def setdesc(self, desc):
        self.vars["desc"] = desc

    def setstatus(self, status):
        self.vars["status"] = status

    def setpriority(self, priority):
        self.vars["priority"] = priority

    def setfixer(self, fixer):
        self.vars["fixer"] = fixer

    def getnotes(self):
        try: file = open(self.dir + "/notes")
        except: return ""
        notes = file.read()
        file.close()
        return notes

    def addnote(self, author, note):
        mkpath(self.dir)
        now = maketimedate(time.time())
        note = string.strip(note)
        try: file = open(self.dir + "/notes", "a")
        except: file = open(self.dir + "/notes", "w")
        try: os.chmod(self.dir + "/notes", 0666)
        except: pass

        file.write("--- %s at %s\n" % (author, now) + note + "\n\n")
        file.close()

    def getmail(self):
        try: file = open(self.dir + "/mbox")
        except: return ""
        mail = file.read()
        file.close()
        return mail

    def addmail(self, message):
        mkpath(self.dir)
        try: file = open(self.dir + "/mbox", "a")
        except: file = open(self.dir + "/mbox", "w")
        try: os.chmod(self.dir + "/mbox", 0666)
        except: pass
        file.write("\nFrom - %s\n" % time.asctime(time.localtime(time.time())))
        file.write(message)
        file.write("\n")
        file.close()

    def save(self):
        mkpath(self.dir)
        if not self.vars.has_key("ctime"):
            self.vars["ctime"] = time.time()

        file = open(self.dir + "/info", "w")
        try: os.chmod(self.dir + "/info", 0666)
        except: pass
        for var in self.vars.keys():
            if var[:1] == "_": continue
            file.write(var + " = " + repr(self.vars[var]) + "\n")
        file.close()

    def describe(self, old={}):
        def change(name, value, old=old):
            oldvalue = string.strip(dict_get(old, name, ""))
            value = string.strip(value)
            if oldvalue != value: return "%s -> %s" % (oldvalue, value)
            return value

        text = []
        text.append("Bug: %s (%s/%s)" % (self.id, ROUNDUPURL, self.id))
        text.append("Description: %s" % change("desc", self.getdesc()))
        text.append("Status: %s" % change("status", self.getstatus()))
        text.append("Priority: %s" % change("priority", self.getpriority()))
        text.append("Fixer: %s" % change("fixer", self.getfixer()))
        text.append("Nosy: %s" % change("nosy", self.getnosy()))
        return string.join(text, "\n")
